<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>magpar: llg/checkiterationllg.c Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<!-- Generated by Doxygen 1.6.3 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Data&nbsp;Structures</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.html"><span>File&nbsp;List</span></a></li>
      <li><a href="globals.html"><span>Globals</span></a></li>
    </ul>
  </div>
  <div class="navpath"><a class="el" href="dir_ad11b878d2835527517911859427b54f.html">llg</a>
  </div>
</div>
<div class="contents">
<h1>checkiterationllg.c</h1><a href="checkiterationllg_8c.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">    This file is part of magpar.</span>
<a name="l00003"></a>00003 <span class="comment"></span>
<a name="l00004"></a>00004 <span class="comment">    Copyright (C) 2002-2010 Werner Scholz</span>
<a name="l00005"></a>00005 <span class="comment"></span>
<a name="l00006"></a>00006 <span class="comment">    www:   http://www.magpar.net/</span>
<a name="l00007"></a>00007 <span class="comment">    email: magpar(at)magpar.net</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">    magpar is free software; you can redistribute it and/or modify</span>
<a name="l00010"></a>00010 <span class="comment">    it under the terms of the GNU General Public License as published by</span>
<a name="l00011"></a>00011 <span class="comment">    the Free Software Foundation; either version 2 of the License, or</span>
<a name="l00012"></a>00012 <span class="comment">    (at your option) any later version.</span>
<a name="l00013"></a>00013 <span class="comment"></span>
<a name="l00014"></a>00014 <span class="comment">    magpar is distributed in the hope that it will be useful,</span>
<a name="l00015"></a>00015 <span class="comment">    but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00016"></a>00016 <span class="comment">    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the</span>
<a name="l00017"></a>00017 <span class="comment">    GNU General Public License for more details.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">    You should have received a copy of the GNU General Public License</span>
<a name="l00020"></a>00020 <span class="comment">    along with magpar; if not, write to the Free Software</span>
<a name="l00021"></a>00021 <span class="comment">    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00022"></a>00022 <span class="comment">*/</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Id[] = <span class="stringliteral">&quot;$Id: checkiterationllg.c 2986 2010-02-23 18:20:01Z scholz $\n\n&quot;</span>;
<a name="l00025"></a>00025 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Td[] = <span class="stringliteral">&quot;$Today: &quot;</span> __FILE__ <span class="stringliteral">&quot;  &quot;</span> __DATE__ <span class="stringliteral">&quot;  &quot;</span>  __TIME__  <span class="stringliteral">&quot; $\n\n&quot;</span>;
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="llg_8h.html">llg.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="magpario_8h.html">io/magpario.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="util_8h.html">util/util.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="field_8h.html">field/field.h</a>&quot;</span>
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 <span class="preprocessor">#ifdef ADDONS</span>
<a name="l00033"></a>00033 <span class="preprocessor"></span><span class="preprocessor">#include &quot;addons/addons.h&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#endif</span>
<a name="l00035"></a>00035 <span class="preprocessor"></span>
<a name="l00036"></a>00036 <span class="keyword">static</span> <span class="keywordtype">int</span>         doinit=1;
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 <span class="keyword">static</span> PetscReal   tol;
<a name="l00039"></a>00039 <span class="keyword">static</span> PetscReal   renormtol=-1.0;
<a name="l00040"></a>00040 <span class="keyword">static</span> <span class="keywordtype">int</span>         condinp_equil;
<a name="l00041"></a>00041 <span class="keyword">static</span> PetscReal   condinp_j;
<a name="l00042"></a>00042 <span class="keyword">static</span> PetscReal   condinp_equil_j;
<a name="l00043"></a>00043 <span class="keyword">static</span> PetscReal   condinp_t;
<a name="l00044"></a>00044 <span class="keyword">static</span> PetscReal   *condinp_user=PETSC_NULL;
<a name="l00045"></a>00045 <span class="keyword">static</span> <span class="keywordtype">int</span>         userinptot = 0;
<a name="l00046"></a>00046 
<a name="l00047"></a>00047 <span class="keyword">static</span> PetscRandom rctx=PETSC_NULL;
<a name="l00048"></a>00048 <span class="keyword">static</span> PetscReal   magdist = 0.0;
<a name="l00049"></a>00049 <span class="keyword">static</span> PetscReal   magdist_ns = 1.0;
<a name="l00050"></a>00050 <span class="keyword">static</span> PetscReal   magdist_last_time = PETSC_MIN;
<a name="l00051"></a>00051 
<a name="l00052"></a>00052 <span class="comment">/* TODO: resolve this extern dependency */</span>
<a name="l00053"></a>00053 <span class="keyword">extern</span> KSP <a class="code" href="hdemag_8c.html#aeb58d58499890ec560bf98f9784c25c6">ksp_Au1</a>;
<a name="l00054"></a>00054 <span class="keyword">extern</span> KSP <a class="code" href="hdemag_8c.html#a41beef8c4d077774a4153eac70ef0bae">ksp_Au2</a>;
<a name="l00055"></a>00055 <span class="keyword">extern</span> realtype <a class="code" href="checkiterationllg_8c.html#aec51da788a337a7317e3b25e8a634716">abstol</a>, <a class="code" href="checkiterationllg_8c.html#a29c891f86d4e498ef78fe8d82ac95ea6">reltol</a>; 
<a name="l00057"></a><a class="code" href="checkiterationllg_8c.html#a3e96e10ed0445f8b608b47231b4f6184">00057</a> <span class="keywordtype">int</span> <a class="code" href="checkiterationllg_8c.html#a3e96e10ed0445f8b608b47231b4f6184">adjtoldem</a>(<a class="code" href="structGridData.html">GridData</a> *gdata, <span class="keywordtype">double</span> fac)
<a name="l00058"></a>00058 {
<a name="l00059"></a>00059   <a class="code" href="griddata_8h.html#a4e81d68a7df0ff55ea65b46253e07552">MagparFunctionInfoBegin</a>;
<a name="l00060"></a>00060 
<a name="l00061"></a>00061   <span class="keywordflow">if</span> (gdata-&gt;<a class="code" href="structGridData.html#a776aed135c71061b20ec61cdbb39604d">VHdem</a>==PETSC_NULL) {
<a name="l00062"></a>00062     <a class="code" href="griddata_8h.html#a3a0efa409c6998ac8e9d7b30da6a8171">MagparFunctionInfoReturn</a>(0);
<a name="l00063"></a>00063   }
<a name="l00064"></a>00064 
<a name="l00065"></a>00065   PetscReal rtol, atol, dtol;
<a name="l00066"></a>00066   <span class="keywordtype">int</span> maxits;
<a name="l00067"></a>00067 
<a name="l00068"></a>00068   ierr = KSPGetTolerances(<a class="code" href="hdemag_8c.html#aeb58d58499890ec560bf98f9784c25c6">ksp_Au1</a>,&amp;rtol,&amp;atol,&amp;dtol,(<a class="code" href="griddata_8h.html#a515706180f960b30595b607f2d734d14" title="Contains all data to control the simulations.">PetscInt</a>*)&amp;maxits);CHKERRQ(ierr);
<a name="l00069"></a>00069 
<a name="l00070"></a>00070   <span class="keywordflow">if</span> (rtol &lt; 1e-10) {
<a name="l00071"></a>00071     <a class="code" href="griddata_8h.html#a3a0efa409c6998ac8e9d7b30da6a8171">MagparFunctionInfoReturn</a>(0);
<a name="l00072"></a>00072   }
<a name="l00073"></a>00073 
<a name="l00074"></a>00074   atol *= fac;
<a name="l00075"></a>00075   rtol *= fac;
<a name="l00076"></a>00076   ierr = KSPSetTolerances(<a class="code" href="hdemag_8c.html#aeb58d58499890ec560bf98f9784c25c6">ksp_Au1</a>,rtol,atol,dtol,maxits);CHKERRQ(ierr);
<a name="l00077"></a>00077 
<a name="l00078"></a>00078   PetscReal time_ns = gdata-&gt;<a class="code" href="structGridData.html#a9eb9246406e97a2a4a8a9c471b11aa2a">time</a>*gdata-&gt;<a class="code" href="structGridData.html#ad7a22de0cb266e66e8dbcb1bb147bae8">tscale</a>*1e9;
<a name="l00079"></a>00079   PetscPrintf(PETSC_COMM_WORLD,
<a name="l00080"></a>00080     <span class="stringliteral">&quot;at t=%g ns: &quot;</span>,time_ns
<a name="l00081"></a>00081   );
<a name="l00082"></a>00082 
<a name="l00083"></a>00083   PetscPrintf(PETSC_COMM_WORLD,
<a name="l00084"></a>00084     <span class="stringliteral">&quot;%s KSP reltol to %g , abstol to %g\n&quot;</span>,
<a name="l00085"></a>00085     fac&gt;1.0 ? <span class="stringliteral">&quot;Increased&quot;</span> : <span class="stringliteral">&quot;Reduced&quot;</span>,
<a name="l00086"></a>00086     rtol,atol
<a name="l00087"></a>00087   );
<a name="l00088"></a>00088 
<a name="l00089"></a>00089   ierr = KSPGetTolerances(<a class="code" href="hdemag_8c.html#a41beef8c4d077774a4153eac70ef0bae">ksp_Au2</a>,&amp;rtol,&amp;atol,&amp;dtol,(<a class="code" href="griddata_8h.html#a515706180f960b30595b607f2d734d14" title="Contains all data to control the simulations.">PetscInt</a>*)&amp;maxits);CHKERRQ(ierr);
<a name="l00090"></a>00090   atol *= fac;
<a name="l00091"></a>00091   rtol *= fac;
<a name="l00092"></a>00092   ierr = KSPSetTolerances(<a class="code" href="hdemag_8c.html#a41beef8c4d077774a4153eac70ef0bae">ksp_Au2</a>,rtol,atol,dtol,maxits);CHKERRQ(ierr);
<a name="l00093"></a>00093 
<a name="l00094"></a>00094   <a class="code" href="griddata_8h.html#a3a0efa409c6998ac8e9d7b30da6a8171">MagparFunctionInfoReturn</a>(0);
<a name="l00095"></a>00095 }
<a name="l00096"></a>00096 
<a name="l00097"></a>00097 
<a name="l00098"></a><a class="code" href="checkiterationllg_8c.html#a4ff7d0e1586041652124b1189f59b881">00098</a> <span class="keywordtype">int</span> <a class="code" href="checkiterationllg_8c.html#a4ff7d0e1586041652124b1189f59b881">adjtol</a>(<a class="code" href="structGridData.html">GridData</a> *gdata, <span class="keywordtype">double</span> fac)
<a name="l00099"></a>00099 {
<a name="l00100"></a>00100   <a class="code" href="griddata_8h.html#a4e81d68a7df0ff55ea65b46253e07552">MagparFunctionInfoBegin</a>;
<a name="l00101"></a>00101 
<a name="l00102"></a>00102   <span class="keywordflow">if</span> (<a class="code" href="checkiterationllg_8c.html#a29c891f86d4e498ef78fe8d82ac95ea6">reltol</a> &lt; 1e-10) {
<a name="l00103"></a>00103     <a class="code" href="griddata_8h.html#a3a0efa409c6998ac8e9d7b30da6a8171">MagparFunctionInfoReturn</a>(0);
<a name="l00104"></a>00104   }
<a name="l00105"></a>00105 
<a name="l00106"></a>00106   PetscReal time_ns = gdata-&gt;<a class="code" href="structGridData.html#a9eb9246406e97a2a4a8a9c471b11aa2a">time</a>*gdata-&gt;<a class="code" href="structGridData.html#ad7a22de0cb266e66e8dbcb1bb147bae8">tscale</a>*1e9;
<a name="l00107"></a>00107   PetscPrintf(PETSC_COMM_WORLD,
<a name="l00108"></a>00108     <span class="stringliteral">&quot;at t=%g ns: &quot;</span>,time_ns
<a name="l00109"></a>00109   );
<a name="l00110"></a>00110 
<a name="l00111"></a>00111   <a class="code" href="checkiterationllg_8c.html#a3e96e10ed0445f8b608b47231b4f6184">adjtoldem</a>(gdata,fac);
<a name="l00112"></a>00112 
<a name="l00113"></a>00113   <a class="code" href="checkiterationllg_8c.html#a29c891f86d4e498ef78fe8d82ac95ea6">reltol</a> *= fac;
<a name="l00114"></a>00114   <a class="code" href="checkiterationllg_8c.html#aec51da788a337a7317e3b25e8a634716">abstol</a> *= fac;
<a name="l00115"></a>00115 
<a name="l00116"></a>00116   <span class="keyword">extern</span> <span class="keywordtype">void</span> *<a class="code" href="mytscreatepvode_8c.html#a809fb699daf418600ff788f3826954c9">cvode_mem</a>;
<a name="l00117"></a>00117   <span class="keywordtype">long</span> <span class="keywordtype">int</span> nstep;
<a name="l00118"></a>00118   <span class="keywordtype">int</span> flag;
<a name="l00119"></a>00119   flag=CVodeGetNumSteps(cvode_mem,&amp;nstep);
<a name="l00120"></a>00120   PetscPrintf(PETSC_COMM_WORLD,
<a name="l00121"></a>00121     <span class="stringliteral">&quot;%s PVODE reltol to %g , abstol to %g ; nstep since last reinit: %i\n&quot;</span>,
<a name="l00122"></a>00122     fac&gt;1.0 ? <span class="stringliteral">&quot;Increased&quot;</span> : <span class="stringliteral">&quot;Reduced&quot;</span>,
<a name="l00123"></a>00123     <a class="code" href="checkiterationllg_8c.html#a29c891f86d4e498ef78fe8d82ac95ea6">reltol</a>,<a class="code" href="checkiterationllg_8c.html#aec51da788a337a7317e3b25e8a634716">abstol</a>,nstep
<a name="l00124"></a>00124   );
<a name="l00125"></a>00125 
<a name="l00126"></a>00126   ierr = <a class="code" href="mytscreatepvode_8c.html#a4ca0e9d74cde3d8e01ad9701426444da">PVodeReInit</a>(gdata);CHKERRQ(ierr);
<a name="l00127"></a>00127 
<a name="l00128"></a>00128   <a class="code" href="griddata_8h.html#a3a0efa409c6998ac8e9d7b30da6a8171">MagparFunctionInfoReturn</a>(0);
<a name="l00129"></a>00129 }
<a name="l00130"></a>00130 
<a name="l00131"></a>00131 
<a name="l00132"></a><a class="code" href="checkiterationllg_8c.html#a5d6bf5e0146588628618631eb234060d">00132</a> <span class="keywordtype">int</span> <a class="code" href="checkiterationllg_8c.html#a5d6bf5e0146588628618631eb234060d">EquilCheck</a>(Vec M,PetscReal time,PetscReal *torque)
<a name="l00133"></a>00133 {
<a name="l00134"></a>00134   <span class="keyword">static</span> PetscReal tlast=time-0.00001;
<a name="l00135"></a>00135   <span class="keyword">static</span> Vec Mold=PETSC_NULL;
<a name="l00136"></a>00136 
<a name="l00137"></a>00137   <a class="code" href="griddata_8h.html#a4e81d68a7df0ff55ea65b46253e07552">MagparFunctionInfoBegin</a>;
<a name="l00138"></a>00138 
<a name="l00139"></a>00139   <span class="comment">/* initialize upon first call */</span>
<a name="l00140"></a>00140   <span class="keywordflow">if</span> (Mold==PETSC_NULL) {
<a name="l00141"></a>00141     ierr = VecDuplicate(M,&amp;Mold);CHKERRQ(ierr);
<a name="l00142"></a>00142     ierr = VecZeroEntries(Mold);CHKERRQ(ierr);
<a name="l00143"></a>00143 
<a name="l00144"></a>00144     <span class="comment">/* copy M */</span>
<a name="l00145"></a>00145     ierr = VecCopy(M,Mold);CHKERRQ(ierr);
<a name="l00146"></a>00146     <span class="comment">/* return fake value since we have not done any timesteps yet</span>
<a name="l00147"></a>00147 <span class="comment">       just larger than the tolerance to keep the simulation running</span>
<a name="l00148"></a>00148 <span class="comment">    */</span>
<a name="l00149"></a>00149     *torque=tol*1.01;
<a name="l00150"></a>00150 
<a name="l00151"></a>00151     <a class="code" href="griddata_8h.html#a3a0efa409c6998ac8e9d7b30da6a8171">MagparFunctionInfoReturn</a>(0);
<a name="l00152"></a>00152   }
<a name="l00153"></a>00153 
<a name="l00154"></a>00154   ierr = VecAXPY(Mold,-1.0,M);CHKERRQ(ierr);
<a name="l00155"></a>00155 
<a name="l00156"></a>00156   <span class="comment">/* calculate norm of delta M */</span>
<a name="l00157"></a>00157   *torque=<a class="code" href="renormvec_8c.html#abba3d002260d6e3e062ac69a80300aa4">RenormVec</a>(Mold,0.0,PETSC_MAX,<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>)/(time-tlast);
<a name="l00158"></a>00158 
<a name="l00159"></a>00159   ierr = VecCopy(M,Mold);CHKERRQ(ierr);
<a name="l00160"></a>00160 
<a name="l00161"></a>00161   tlast=time;
<a name="l00162"></a>00162 
<a name="l00163"></a>00163   <a class="code" href="griddata_8h.html#a9a4d090c28602d7ff7ec883fb6f413db">MagparFunctionProfReturn</a>(0);
<a name="l00164"></a>00164 }
<a name="l00165"></a>00165 
<a name="l00166"></a>00166 
<a name="l00167"></a><a class="code" href="checkiterationllg_8c.html#a3f86d8b6fe0ca41eb041d4130e854c6f">00167</a> <span class="keywordtype">int</span> <a class="code" href="checkiterationllg_8c.html#a3f86d8b6fe0ca41eb041d4130e854c6f">CheckIterationLLG_Init</a>(<a class="code" href="structGridData.html">GridData</a> *gdata)
<a name="l00168"></a>00168 {
<a name="l00169"></a>00169   PetscTruth flg;
<a name="l00170"></a>00170 
<a name="l00171"></a>00171   <a class="code" href="griddata_8h.html#a3d9da926137619fd02adb245a08536c7">MagparFunctionLogBegin</a>;
<a name="l00172"></a>00172   <span class="keywordtype">char</span> fn[256];
<a name="l00173"></a>00173   <span class="keywordtype">char</span> line[256];
<a name="l00174"></a>00174   <span class="keywordtype">int</span> rank;
<a name="l00175"></a>00175   ierr = MPI_Comm_rank(PETSC_COMM_WORLD,&amp;rank);CHKERRQ(ierr);
<a name="l00176"></a>00176 
<a name="l00177"></a>00177   ierr = PetscOptionsGetReal(PETSC_NULL,<span class="stringliteral">&quot;-renormtol&quot;</span>,&amp;renormtol,&amp;flg);CHKERRQ(ierr);
<a name="l00178"></a>00178   <span class="keywordflow">if</span> (flg!=PETSC_TRUE) {
<a name="l00179"></a>00179     renormtol=1e-2;
<a name="l00180"></a>00180     PetscPrintf(PETSC_COMM_WORLD,
<a name="l00181"></a>00181       <span class="stringliteral">&quot;Option -renormtol not found, using default value: %g\n&quot;</span>,
<a name="l00182"></a>00182       renormtol
<a name="l00183"></a>00183     );
<a name="l00184"></a>00184   }
<a name="l00185"></a>00185   PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;renormtol:   %g\n&quot;</span>,renormtol);
<a name="l00186"></a>00186 
<a name="l00187"></a>00187   ierr = PetscOptionsGetReal(PETSC_NULL,<span class="stringliteral">&quot;-tol&quot;</span>,&amp;tol,&amp;flg);CHKERRQ(ierr);
<a name="l00188"></a>00188   <span class="keywordflow">if</span> (flg!=PETSC_TRUE) {
<a name="l00189"></a>00189     tol=1e-5;
<a name="l00190"></a>00190     PetscPrintf(PETSC_COMM_WORLD,
<a name="l00191"></a>00191       <span class="stringliteral">&quot;Option -tol not found, using default value: %g\n&quot;</span>,
<a name="l00192"></a>00192       tol
<a name="l00193"></a>00193     );
<a name="l00194"></a>00194   }
<a name="l00195"></a>00195   PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;tol (equilibrium): %g\n&quot;</span>,tol);
<a name="l00196"></a>00196 
<a name="l00197"></a>00197   <span class="keywordflow">if</span> (<a class="code" href="checkiterationllg_8c.html#aec51da788a337a7317e3b25e8a634716">abstol</a> &gt; tol/10.0) {
<a name="l00198"></a>00198     PetscPrintf(PETSC_COMM_WORLD,
<a name="l00199"></a>00199       <span class="stringliteral">&quot;Warning: abstol=%g should be &lt; (tol=%g)/10.0!\n&quot;</span>,
<a name="l00200"></a>00200       <a class="code" href="checkiterationllg_8c.html#aec51da788a337a7317e3b25e8a634716">abstol</a>,
<a name="l00201"></a>00201       tol
<a name="l00202"></a>00202     );
<a name="l00203"></a>00203   }
<a name="l00204"></a>00204 
<a name="l00205"></a>00205   ierr = PetscOptionsGetInt(PETSC_NULL,<span class="stringliteral">&quot;-condinp_equil&quot;</span>, (<a class="code" href="griddata_8h.html#a515706180f960b30595b607f2d734d14" title="Contains all data to control the simulations.">PetscInt</a>*)&amp;condinp_equil, &amp;flg);CHKERRQ(ierr);
<a name="l00206"></a>00206   <span class="keywordflow">if</span> (flg!=PETSC_TRUE) {
<a name="l00207"></a>00207     condinp_equil=1;
<a name="l00208"></a>00208     PetscPrintf(PETSC_COMM_WORLD,
<a name="l00209"></a>00209       <span class="stringliteral">&quot;Option -condinp_equil not found, using default value: %i\n&quot;</span>,
<a name="l00210"></a>00210       condinp_equil
<a name="l00211"></a>00211     );
<a name="l00212"></a>00212   }
<a name="l00213"></a>00213   ierr = PetscOptionsGetReal(PETSC_NULL,<span class="stringliteral">&quot;-condinp_j&quot;</span>,&amp;condinp_j,&amp;flg);CHKERRQ(ierr);
<a name="l00214"></a>00214   <span class="keywordflow">if</span> (flg!=PETSC_TRUE) {
<a name="l00215"></a>00215     condinp_j=0.1;
<a name="l00216"></a>00216     PetscPrintf(PETSC_COMM_WORLD,
<a name="l00217"></a>00217       <span class="stringliteral">&quot;Option -condinp_j not found, using default value: %g\n&quot;</span>,
<a name="l00218"></a>00218       condinp_j
<a name="l00219"></a>00219     );
<a name="l00220"></a>00220   }
<a name="l00221"></a>00221   ierr = PetscOptionsGetReal(PETSC_NULL,<span class="stringliteral">&quot;-condinp_equil_j&quot;</span>,&amp;condinp_equil_j,&amp;flg);CHKERRQ(ierr);
<a name="l00222"></a>00222   <span class="keywordflow">if</span> (flg!=PETSC_TRUE) {
<a name="l00223"></a>00223     condinp_equil_j=0.0;
<a name="l00224"></a>00224     PetscPrintf(PETSC_COMM_WORLD,
<a name="l00225"></a>00225       <span class="stringliteral">&quot;Option -condinp_equil_j not found, using default value: %g\n&quot;</span>,
<a name="l00226"></a>00226       condinp_equil_j
<a name="l00227"></a>00227     );
<a name="l00228"></a>00228   }
<a name="l00229"></a>00229   ierr = PetscOptionsGetReal(PETSC_NULL,<span class="stringliteral">&quot;-condinp_t&quot;</span>,&amp;condinp_t,&amp;flg);CHKERRQ(ierr);
<a name="l00230"></a>00230   <span class="keywordflow">if</span> (flg!=PETSC_TRUE) {
<a name="l00231"></a>00231     condinp_t=PETSC_MAX;
<a name="l00232"></a>00232     PetscPrintf(PETSC_COMM_WORLD,
<a name="l00233"></a>00233       <span class="stringliteral">&quot;Option -condinp_t not found, using default value: %g\n&quot;</span>,
<a name="l00234"></a>00234       condinp_t
<a name="l00235"></a>00235     );
<a name="l00236"></a>00236   }
<a name="l00237"></a>00237 
<a name="l00238"></a>00238   <span class="comment">/* user times in file name specified by -condinp_user */</span>
<a name="l00239"></a>00239   ierr = PetscOptionsGetString(PETSC_NULL,<span class="stringliteral">&quot;-condinp_file_t_ns&quot;</span>,fn,<span class="keyword">sizeof</span>(fn),&amp;flg);CHKERRQ(ierr);
<a name="l00240"></a>00240   <span class="keywordflow">if</span> (flg!=PETSC_TRUE) {
<a name="l00241"></a>00241     PetscPrintf(PETSC_COMM_WORLD,
<a name="l00242"></a>00242       <span class="stringliteral">&quot;Option -condinp_file_t_ns not found, user inp output times NOT activated\n&quot;</span>
<a name="l00243"></a>00243     );
<a name="l00244"></a>00244     userinptot = 0;
<a name="l00245"></a>00245   }
<a name="l00246"></a>00246   <span class="keywordflow">else</span> {
<a name="l00247"></a>00247     <span class="keywordflow">if</span> (!rank) {
<a name="l00248"></a>00248       FILE *fd=NULL;
<a name="l00249"></a>00249       PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;Opening condinp_file_t_ns file %s\n&quot;</span>,fn);
<a name="l00250"></a>00250       ierr = PetscFOpen(PETSC_COMM_WORLD,fn,<span class="stringliteral">&quot;r&quot;</span>,&amp;fd);CHKERRQ(ierr);
<a name="l00251"></a>00251       <span class="keywordflow">if</span> (!fd){
<a name="l00252"></a>00252         SETERRQ1(PETSC_ERR_FILE_OPEN,<span class="stringliteral">&quot;Cannot open %s\n&quot;</span>,fn);
<a name="l00253"></a>00253       }
<a name="l00254"></a>00254       <a class="code" href="magpario_8h.html#a85c6fd604f4655acf9edea63969a5676">read_one_line</a>(fd,line,<span class="keyword">sizeof</span>(line),NULL);
<a name="l00255"></a>00255       <span class="keywordflow">if</span> (sscanf(line,<span class="stringliteral">&quot;%i&quot;</span>,&amp;userinptot) != 1) {
<a name="l00256"></a>00256         SETERRQ(PETSC_ERR_FILE_UNEXPECTED,<span class="stringliteral">&quot;could not read number of user inp values\n&quot;</span>);
<a name="l00257"></a>00257       }
<a name="l00258"></a>00258       <span class="comment">/* alloc memory to store user time values */</span>
<a name="l00259"></a>00259       ierr = PetscMalloc(userinptot*<span class="keyword">sizeof</span>(PetscReal),&amp;condinp_user);CHKERRQ(ierr);
<a name="l00260"></a>00260 
<a name="l00261"></a>00261       <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0;i&lt;userinptot;i++) {
<a name="l00262"></a>00262         <a class="code" href="magpario_8h.html#a85c6fd604f4655acf9edea63969a5676">read_one_line</a>(fd,line,<span class="keyword">sizeof</span>(line),NULL);
<a name="l00263"></a>00263         <span class="keywordflow">if</span> (sscanf(line,<span class="stringliteral">&quot;%lf&quot;</span>,condinp_user + i) != 1) {
<a name="l00264"></a>00264         SETERRQ1(PETSC_ERR_FILE_UNEXPECTED,<span class="stringliteral">&quot;could not read user inp time value %i\n&quot;</span>,i);
<a name="l00265"></a>00265         }
<a name="l00266"></a>00266         condinp_user[i] /= 1e9*gdata-&gt;<a class="code" href="structGridData.html#ad7a22de0cb266e66e8dbcb1bb147bae8">tscale</a>;
<a name="l00267"></a>00267       }
<a name="l00268"></a>00268 
<a name="l00269"></a>00269       PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;Number of user inp output times read in: %i\n&quot;</span>,userinptot);
<a name="l00270"></a>00270       ierr = PetscFClose(PETSC_COMM_WORLD,fd);CHKERRQ(ierr);
<a name="l00271"></a>00271     }
<a name="l00272"></a>00272     <span class="comment">/* broadcast condinp_user data to all processors */</span>
<a name="l00273"></a>00273     ierr = MPI_Bcast(&amp;userinptot,1,MPI_INT,0,PETSC_COMM_WORLD);CHKERRQ(ierr);
<a name="l00274"></a>00274     <span class="keywordflow">if</span> (rank) {
<a name="l00275"></a>00275       ierr = PetscMalloc(userinptot*<span class="keyword">sizeof</span>(PetscReal),&amp;condinp_user);CHKERRQ(ierr);
<a name="l00276"></a>00276     }
<a name="l00277"></a>00277     ierr = MPI_Bcast(condinp_user,userinptot,MPIU_SCALAR,0,PETSC_COMM_WORLD);CHKERRQ(ierr);
<a name="l00278"></a>00278   }
<a name="l00279"></a>00279   condinp_t /= 1e9*gdata-&gt;<a class="code" href="structGridData.html#ad7a22de0cb266e66e8dbcb1bb147bae8">tscale</a>;
<a name="l00280"></a>00280 
<a name="l00281"></a>00281   <span class="comment">/* disturb magnetization distribution with random vector */</span>
<a name="l00282"></a>00282   ierr = PetscOptionsGetReal(PETSC_NULL,<span class="stringliteral">&quot;-magdist_llg&quot;</span>, &amp;magdist,&amp;flg);CHKERRQ(ierr);
<a name="l00283"></a>00283   <span class="keywordflow">if</span> (flg!=PETSC_TRUE) {
<a name="l00284"></a>00284     magdist=0.0;
<a name="l00285"></a>00285     PetscPrintf(PETSC_COMM_WORLD,
<a name="l00286"></a>00286       <span class="stringliteral">&quot;Option -magdist_llg not found, using default value: %g\n&quot;</span>,
<a name="l00287"></a>00287       magdist
<a name="l00288"></a>00288     );
<a name="l00289"></a>00289   }
<a name="l00290"></a>00290 
<a name="l00291"></a>00291   <span class="keywordflow">if</span> (magdist&gt;0.0) {
<a name="l00292"></a>00292     ierr = PetscOptionsGetReal(PETSC_NULL,<span class="stringliteral">&quot;-magdist_ns&quot;</span>, &amp;magdist_ns,&amp;flg);CHKERRQ(ierr);
<a name="l00293"></a>00293     <span class="keywordflow">if</span> (flg!=PETSC_TRUE) {
<a name="l00294"></a>00294       magdist_ns=1.0;
<a name="l00295"></a>00295       PetscPrintf(PETSC_COMM_WORLD,
<a name="l00296"></a>00296         <span class="stringliteral">&quot;Option -magdist_ns not found, using default value: %g\n&quot;</span>,
<a name="l00297"></a>00297         magdist_ns
<a name="l00298"></a>00298       );
<a name="l00299"></a>00299     }
<a name="l00300"></a>00300 
<a name="l00301"></a>00301     PetscReal time_ns = gdata-&gt;<a class="code" href="structGridData.html#a9eb9246406e97a2a4a8a9c471b11aa2a">time</a>*gdata-&gt;<a class="code" href="structGridData.html#ad7a22de0cb266e66e8dbcb1bb147bae8">tscale</a>*1e9;
<a name="l00302"></a>00302     magdist_last_time = time_ns;
<a name="l00303"></a>00303     PetscPrintf(PETSC_COMM_WORLD,
<a name="l00304"></a>00304       <span class="stringliteral">&quot;Initializing magdist_last_time: %g ns\n&quot;</span>,
<a name="l00305"></a>00305       magdist_last_time
<a name="l00306"></a>00306     );
<a name="l00307"></a>00307 
<a name="l00308"></a>00308     ierr = PetscRandomCreate(PETSC_COMM_WORLD,&amp;rctx);CHKERRQ(ierr);
<a name="l00309"></a>00309     ierr = PetscRandomSetFromOptions(rctx);CHKERRQ(ierr);
<a name="l00310"></a>00310 
<a name="l00311"></a>00311     PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;Applying magnetization disturbance of %g every %g ns.\n&quot;</span>,magdist,magdist_ns);
<a name="l00312"></a>00312   }
<a name="l00313"></a>00313 
<a name="l00314"></a>00314   <a class="code" href="griddata_8h.html#a8491466d8534a33d7163f5ea747e8210">MagparFunctionLogReturn</a>(0);
<a name="l00315"></a>00315 }
<a name="l00316"></a>00316 
<a name="l00317"></a>00317 
<a name="l00318"></a><a class="code" href="checkiterationllg_8c.html#a5433821a82b3ad3af34bb43677541a33">00318</a> <span class="keywordtype">int</span> <a class="code" href="checkiterationllg_8c.html#a5433821a82b3ad3af34bb43677541a33">CheckIterationLLG</a>(<a class="code" href="structGridData.html">GridData</a> *gdata)
<a name="l00319"></a>00319 {
<a name="l00320"></a>00320   <span class="keyword">static</span> PetscReal Etotold=PETSC_MAX;
<a name="l00321"></a>00321   <span class="keyword">static</span> PetscReal hextold=PETSC_MAX;
<a name="l00322"></a>00322   <span class="keyword">static</span> PetscReal condinp_last_t=PETSC_MIN;
<a name="l00323"></a>00323   <span class="keyword">static</span> PetscReal condinp_last_j=PETSC_MIN;
<a name="l00324"></a>00324   <span class="keyword">static</span> PetscReal condinp_last_equil_j=PETSC_MIN;
<a name="l00325"></a>00325 
<a name="l00326"></a>00326   <span class="keyword">const</span> PetscReal  tolscale=3.0;
<a name="l00327"></a>00327 
<a name="l00328"></a>00328   <span class="keyword">static</span> <span class="keywordtype">int</span> nsteps=-1;
<a name="l00329"></a>00329   <span class="keyword">static</span> <span class="keywordtype">int</span> csteps;
<a name="l00330"></a>00330 
<a name="l00331"></a>00331   <span class="keyword">static</span> PetscReal Edemold=gdata-&gt;<a class="code" href="structGridData.html#a93b54f2f6a796c1528054e5b91977287">Edem</a>;
<a name="l00332"></a>00332   <span class="keyword">static</span> PetscReal dEdem1=0;
<a name="l00333"></a>00333   <span class="keyword">static</span> PetscReal dEdem2=0;
<a name="l00334"></a>00334 
<a name="l00335"></a>00335   <span class="keyword">static</span> PetscReal timelast=gdata-&gt;<a class="code" href="structGridData.html#a9eb9246406e97a2a4a8a9c471b11aa2a">time</a>;
<a name="l00336"></a>00336 
<a name="l00337"></a>00337   <span class="keyword">static</span> <span class="keywordtype">int</span> userinpindex = 0;
<a name="l00338"></a>00338 
<a name="l00339"></a>00339 <span class="preprocessor">#undef CHKDMDT</span>
<a name="l00340"></a>00340 <span class="preprocessor"></span><span class="preprocessor">#ifdef CHKDMDT</span>
<a name="l00341"></a>00341 <span class="preprocessor"></span>  <span class="keyword">static</span> Vec dMdt;
<a name="l00342"></a>00342 <span class="preprocessor">#endif</span>
<a name="l00343"></a>00343 <span class="preprocessor"></span>
<a name="l00344"></a>00344   <a class="code" href="griddata_8h.html#a4e81d68a7df0ff55ea65b46253e07552">MagparFunctionInfoBegin</a>;
<a name="l00345"></a>00345 
<a name="l00346"></a>00346   PetscReal time_ns = gdata-&gt;<a class="code" href="structGridData.html#a9eb9246406e97a2a4a8a9c471b11aa2a">time</a>*gdata-&gt;<a class="code" href="structGridData.html#ad7a22de0cb266e66e8dbcb1bb147bae8">tscale</a>*1e9;
<a name="l00347"></a>00347 
<a name="l00348"></a>00348   <span class="comment">/* initialize if necessary */</span>
<a name="l00349"></a>00349   <span class="keywordflow">if</span> (doinit) {
<a name="l00350"></a>00350     ierr = <a class="code" href="checkiterationllg_8c.html#a3f86d8b6fe0ca41eb041d4130e854c6f">CheckIterationLLG_Init</a>(gdata);CHKERRQ(ierr);
<a name="l00351"></a>00351 <span class="preprocessor">#ifdef CHKDMDT</span>
<a name="l00352"></a>00352 <span class="preprocessor"></span>    VecDuplicate(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,&amp;dMdt);
<a name="l00353"></a>00353 <span class="preprocessor">#endif</span>
<a name="l00354"></a>00354 <span class="preprocessor"></span>    doinit=0;
<a name="l00355"></a>00355   }
<a name="l00356"></a>00356 
<a name="l00357"></a>00357 <span class="preprocessor">#ifdef CHKDMDT</span>
<a name="l00358"></a>00358 <span class="preprocessor"></span>  <span class="comment">/* This method could be more expensive than the old method because</span>
<a name="l00359"></a>00359 <span class="comment">     we recalculate all the fields when we call calc_dMdt!</span>
<a name="l00360"></a>00360 <span class="comment">     However, we would get access the old dMdt - then it would be cheaper.</span>
<a name="l00361"></a>00361 <span class="comment">  */</span>
<a name="l00362"></a>00362   PetscReal veq;
<a name="l00363"></a>00363   <a class="code" href="calc__dMdt_8c.html#aa814b25d7c7a65198ca75426fb6d7403">calc_dMdt</a>(PETSC_NULL,0.0,gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,dMdt,gdata);
<a name="l00364"></a>00364   veq=<a class="code" href="renormvec_8c.html#abba3d002260d6e3e062ac69a80300aa4">RenormVec</a>(dMdt,0.0,PETSC_MAX,<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>);
<a name="l00365"></a>00365   gdata-&gt;<a class="code" href="structGridData.html#aa694f80ac28e20e0d11e13a3db947ed4">equil</a>=veq;
<a name="l00366"></a>00366 
<a name="l00367"></a>00367 <span class="preprocessor">#if 1</span>
<a name="l00368"></a>00368 <span class="preprocessor"></span>  ierr = <a class="code" href="checkiterationllg_8c.html#a5d6bf5e0146588628618631eb234060d">EquilCheck</a>(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,gdata-&gt;<a class="code" href="structGridData.html#a9eb9246406e97a2a4a8a9c471b11aa2a">time</a>,&amp;gdata-&gt;<a class="code" href="structGridData.html#ad44d2e83b58c9fc6b13f7fb3258bc323">vequil</a>);CHKERRQ(ierr);
<a name="l00369"></a>00369 <span class="preprocessor">#endif</span>
<a name="l00370"></a>00370 <span class="preprocessor"></span>
<a name="l00371"></a>00371   PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;torque = %g  %g  %g\n&quot;</span>,veq,gdata-&gt;<a class="code" href="structGridData.html#ad44d2e83b58c9fc6b13f7fb3258bc323">vequil</a>,veq/gdata-&gt;<a class="code" href="structGridData.html#ad44d2e83b58c9fc6b13f7fb3258bc323">vequil</a>);
<a name="l00372"></a>00372 <span class="preprocessor">#else</span>
<a name="l00373"></a>00373 <span class="preprocessor"></span>  ierr = <a class="code" href="checkiterationllg_8c.html#a5d6bf5e0146588628618631eb234060d">EquilCheck</a>(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,gdata-&gt;<a class="code" href="structGridData.html#a9eb9246406e97a2a4a8a9c471b11aa2a">time</a>,&amp;gdata-&gt;<a class="code" href="structGridData.html#ad44d2e83b58c9fc6b13f7fb3258bc323">vequil</a>);CHKERRQ(ierr);
<a name="l00374"></a>00374 <span class="preprocessor">#endif</span>
<a name="l00375"></a>00375 <span class="preprocessor"></span>
<a name="l00376"></a>00376   <span class="comment">/* We could also use differential dMdt calculated in calc_dMdt through RHSfunction (see there).</span>
<a name="l00377"></a>00377 <span class="comment">     However, there is more noise than if we take the finite difference over one full time step.</span>
<a name="l00378"></a>00378 <span class="comment">  */</span>
<a name="l00379"></a>00379 
<a name="l00380"></a>00380   <span class="keywordflow">if</span> (gdata-&gt;<a class="code" href="structGridData.html#ad44d2e83b58c9fc6b13f7fb3258bc323">vequil</a> &lt; tol) {
<a name="l00381"></a>00381     <span class="comment">/* count how long we have been in equilibrium in succession */</span>
<a name="l00382"></a>00382     gdata-&gt;<a class="code" href="structGridData.html#aa694f80ac28e20e0d11e13a3db947ed4">equil</a>++;
<a name="l00383"></a>00383   }
<a name="l00384"></a>00384   <span class="keywordflow">else</span> {
<a name="l00385"></a>00385     <span class="comment">/* reset counter if we are not in equilibrium */</span>
<a name="l00386"></a>00386     gdata-&gt;<a class="code" href="structGridData.html#aa694f80ac28e20e0d11e13a3db947ed4">equil</a>=0;
<a name="l00387"></a>00387   }
<a name="l00388"></a>00388 
<a name="l00389"></a>00389   <span class="comment">/* check if total energy increased (which it should not)</span>
<a name="l00390"></a>00390 <span class="comment">     print warning only if external field has not changed</span>
<a name="l00391"></a>00391 <span class="comment">  */</span>
<a name="l00392"></a>00392   PetscReal hext;
<a name="l00393"></a>00393   hext=<a class="code" href="field_8h.html#a48d0086e7ff33076be493f9379c45069">Hexternal_hext</a>();
<a name="l00394"></a>00394   <span class="keywordflow">if</span> (gdata-&gt;<a class="code" href="structGridData.html#a3a7aa0cd7fb9d423a39262c6c0079e62">Etot</a> &gt; Etotold &amp;&amp;
<a name="l00395"></a>00395       hext == hextold &amp;&amp;
<a name="l00396"></a>00396       ((gdata-&gt;<a class="code" href="structGridData.html#a3a7aa0cd7fb9d423a39262c6c0079e62">Etot</a>-Etotold)/Etotold)&gt;1e-8) {
<a name="l00397"></a>00397 
<a name="l00398"></a>00398     PetscPrintf(MPI_COMM_WORLD,
<a name="l00399"></a>00399       <span class="stringliteral">&quot;Warning (t=%g ns): Etot increased by %g (%g*Etot) from %g to %g J/m^3\n&quot;</span>,
<a name="l00400"></a>00400       time_ns,
<a name="l00401"></a>00401       (gdata-&gt;<a class="code" href="structGridData.html#a3a7aa0cd7fb9d423a39262c6c0079e62">Etot</a>-Etotold)*gdata-&gt;<a class="code" href="structGridData.html#af5ca6e17784da000ea45ebb5f65ebd03">escale</a>,
<a name="l00402"></a>00402       (gdata-&gt;<a class="code" href="structGridData.html#a3a7aa0cd7fb9d423a39262c6c0079e62">Etot</a>-Etotold)/Etotold,
<a name="l00403"></a>00403       Etotold*gdata-&gt;<a class="code" href="structGridData.html#af5ca6e17784da000ea45ebb5f65ebd03">escale</a>,
<a name="l00404"></a>00404       gdata-&gt;<a class="code" href="structGridData.html#a3a7aa0cd7fb9d423a39262c6c0079e62">Etot</a>*gdata-&gt;<a class="code" href="structGridData.html#af5ca6e17784da000ea45ebb5f65ebd03">escale</a>
<a name="l00405"></a>00405     );
<a name="l00406"></a>00406 
<a name="l00407"></a>00407 <span class="comment">/*</span>
<a name="l00408"></a>00408 <span class="comment">    ierr = adjtol(gdata,1.0/tolscale);CHKERRQ(ierr);</span>
<a name="l00409"></a>00409 <span class="comment">*/</span>
<a name="l00410"></a>00410   }
<a name="l00411"></a>00411   Etotold=gdata-&gt;<a class="code" href="structGridData.html#a3a7aa0cd7fb9d423a39262c6c0079e62">Etot</a>;
<a name="l00412"></a>00412   hextold=hext;
<a name="l00413"></a>00413 
<a name="l00414"></a>00414   PetscReal valMpHext;
<a name="l00415"></a>00415   ierr = <a class="code" href="field_8h.html#aacac4af746c003dbd608d662ca2272e2">MpHext</a>(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,&amp;valMpHext);CHKERRQ(ierr);
<a name="l00416"></a>00416 
<a name="l00417"></a>00417   <span class="comment">/* check if a set of output data should be written */</span>
<a name="l00418"></a>00418   <span class="keywordflow">if</span> (PetscAbsReal(valMpHext-condinp_last_j) &gt; condinp_j) {
<a name="l00419"></a>00419     gdata-&gt;<a class="code" href="structGridData.html#a4cc9b420611ac5eed22ee3bb2533fde4">inp</a>=PetscAbsInt(gdata-&gt;<a class="code" href="structGridData.html#a4cc9b420611ac5eed22ee3bb2533fde4">inp</a>);
<a name="l00420"></a>00420 
<a name="l00421"></a>00421     condinp_last_t=gdata-&gt;<a class="code" href="structGridData.html#a9eb9246406e97a2a4a8a9c471b11aa2a">time</a>;
<a name="l00422"></a>00422     condinp_last_j=valMpHext;
<a name="l00423"></a>00423   }
<a name="l00424"></a>00424   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (PetscAbsReal(gdata-&gt;<a class="code" href="structGridData.html#a9eb9246406e97a2a4a8a9c471b11aa2a">time</a>-condinp_last_t) &gt; condinp_t) {
<a name="l00425"></a>00425     gdata-&gt;<a class="code" href="structGridData.html#a4cc9b420611ac5eed22ee3bb2533fde4">inp</a>=PetscAbsInt(gdata-&gt;<a class="code" href="structGridData.html#a4cc9b420611ac5eed22ee3bb2533fde4">inp</a>);
<a name="l00426"></a>00426 
<a name="l00427"></a>00427     condinp_last_t=gdata-&gt;<a class="code" href="structGridData.html#a9eb9246406e97a2a4a8a9c471b11aa2a">time</a>;
<a name="l00428"></a>00428     condinp_last_j=valMpHext;
<a name="l00429"></a>00429   }
<a name="l00430"></a>00430   <span class="keywordflow">else</span> <span class="keywordflow">if</span> ( userinpindex &lt; userinptot &amp;&amp; gdata-&gt;time &gt;= condinp_user[userinpindex]) {
<a name="l00431"></a>00431       gdata-&gt;<a class="code" href="structGridData.html#a4cc9b420611ac5eed22ee3bb2533fde4">inp</a>=PetscAbsInt(gdata-&gt;<a class="code" href="structGridData.html#a4cc9b420611ac5eed22ee3bb2533fde4">inp</a>);
<a name="l00432"></a>00432 
<a name="l00433"></a>00433       condinp_last_t=gdata-&gt;<a class="code" href="structGridData.html#a9eb9246406e97a2a4a8a9c471b11aa2a">time</a>;
<a name="l00434"></a>00434       condinp_last_j=valMpHext;
<a name="l00435"></a>00435       userinpindex++;
<a name="l00436"></a>00436   }
<a name="l00437"></a>00437   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (condinp_equil==1 &amp;&amp; gdata-&gt;<a class="code" href="structGridData.html#aa694f80ac28e20e0d11e13a3db947ed4">equil</a> &gt; 0) {
<a name="l00438"></a>00438     <span class="comment">/* check for condinp_equil_j (defaults to 0.0) */</span>
<a name="l00439"></a>00439     <span class="keywordflow">if</span> (PetscAbsReal(valMpHext-condinp_last_equil_j) &gt; condinp_equil_j) {
<a name="l00440"></a>00440       gdata-&gt;<a class="code" href="structGridData.html#a4cc9b420611ac5eed22ee3bb2533fde4">inp</a>=PetscAbsInt(gdata-&gt;<a class="code" href="structGridData.html#a4cc9b420611ac5eed22ee3bb2533fde4">inp</a>);
<a name="l00441"></a>00441 
<a name="l00442"></a>00442       condinp_last_t=gdata-&gt;<a class="code" href="structGridData.html#a9eb9246406e97a2a4a8a9c471b11aa2a">time</a>;
<a name="l00443"></a>00443       condinp_last_j=valMpHext;
<a name="l00444"></a>00444       condinp_last_equil_j=valMpHext;
<a name="l00445"></a>00445     }
<a name="l00446"></a>00446   }
<a name="l00447"></a>00447 
<a name="l00448"></a>00448   <span class="keywordflow">if</span> (nsteps&lt;0) {
<a name="l00449"></a>00449     PetscTruth flg;
<a name="l00450"></a>00450     ierr = PetscOptionsGetInt(PETSC_NULL,<span class="stringliteral">&quot;-ts_logsteps&quot;</span>,(<a class="code" href="griddata_8h.html#a515706180f960b30595b607f2d734d14" title="Contains all data to control the simulations.">PetscInt</a>*)&amp;nsteps,&amp;flg);CHKERRQ(ierr);
<a name="l00451"></a>00451     <span class="keywordflow">if</span> (flg!=PETSC_TRUE) {
<a name="l00452"></a>00452       nsteps=1;
<a name="l00453"></a>00453       PetscPrintf(PETSC_COMM_WORLD,
<a name="l00454"></a>00454         <span class="stringliteral">&quot;Option -ts_logsteps not found, using default value: %i\n&quot;</span>,
<a name="l00455"></a>00455         nsteps
<a name="l00456"></a>00456       );
<a name="l00457"></a>00457     }
<a name="l00458"></a>00458     <span class="keywordflow">if</span> (nsteps&lt;1) {
<a name="l00459"></a>00459       SETERRQ1(PETSC_ERR_ARG_OUTOFRANGE,<span class="stringliteral">&quot;Option set: -ts_logsteps %i, but has to be &gt;0\n&quot;</span>,nsteps);
<a name="l00460"></a>00460     }
<a name="l00461"></a>00461     csteps=0;
<a name="l00462"></a>00462   }
<a name="l00463"></a>00463 
<a name="l00464"></a>00464   <span class="keywordflow">if</span> (csteps % nsteps == 0 || gdata-&gt;<a class="code" href="structGridData.html#aa694f80ac28e20e0d11e13a3db947ed4">equil</a>&gt;0) {
<a name="l00465"></a>00465     ierr = <a class="code" href="magpario_8h.html#ad970cf1663bac1ede525a5caf43750fd">WriteLog</a>(gdata);CHKERRQ(ierr);
<a name="l00466"></a>00466     ierr = <a class="code" href="magpario_8h.html#a7ff05d6bfdfc02445d6245fec57f686e">WriteSet</a>(gdata);CHKERRQ(ierr);
<a name="l00467"></a>00467     csteps=0;
<a name="l00468"></a>00468   }
<a name="l00469"></a>00469   csteps++;
<a name="l00470"></a>00470 
<a name="l00471"></a>00471 <span class="preprocessor">#ifdef ADDONS</span>
<a name="l00472"></a>00472 <span class="preprocessor"></span>  <span class="comment">/* move magnetization if requested */</span>
<a name="l00473"></a>00473   ierr = MovingField(gdata);CHKERRQ(ierr);
<a name="l00474"></a>00474 <span class="preprocessor">#endif</span>
<a name="l00475"></a>00475 <span class="preprocessor"></span>
<a name="l00476"></a>00476   <span class="keyword">extern</span> <span class="keywordtype">void</span> *<a class="code" href="mytscreatepvode_8c.html#a809fb699daf418600ff788f3826954c9">cvode_mem</a>;
<a name="l00477"></a>00477   <span class="keywordtype">long</span> <span class="keywordtype">int</span> nstep;
<a name="l00478"></a>00478   <span class="keywordtype">int</span> flag;
<a name="l00479"></a>00479   flag=CVodeGetNumSteps(cvode_mem,&amp;nstep);
<a name="l00480"></a>00480 
<a name="l00481"></a>00481   <span class="comment">/* update external field if system is in equilibrium */</span>
<a name="l00482"></a>00482   <span class="keywordflow">if</span> (gdata-&gt;<a class="code" href="structGridData.html#aa694f80ac28e20e0d11e13a3db947ed4">equil</a>&gt;0) {
<a name="l00483"></a>00483     ierr = <a class="code" href="field_8h.html#a386ce6c3aee542bfbdfbc8bce99d51fe">Hext_ho_hstep</a>(gdata);CHKERRQ(ierr);
<a name="l00484"></a>00484 
<a name="l00485"></a>00485     <span class="comment">/* check if we are still in equilibrium */</span>
<a name="l00486"></a>00486     <span class="keywordflow">if</span> (gdata-&gt;<a class="code" href="structGridData.html#aa694f80ac28e20e0d11e13a3db947ed4">equil</a>&gt;0) {
<a name="l00487"></a>00487       <span class="comment">/* that&#39;s because the field has not been changed */</span>
<a name="l00488"></a>00488       PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;gdata-&gt;equil %i &gt;= 1\n&quot;</span>,gdata-&gt;<a class="code" href="structGridData.html#aa694f80ac28e20e0d11e13a3db947ed4">equil</a>);
<a name="l00489"></a>00489       gdata-&gt;<a class="code" href="structGridData.html#ae420f7fb3d60720f21c5852955b94eae">mode</a>=99;
<a name="l00490"></a>00490     }
<a name="l00491"></a>00491     <span class="comment">/* restart PVODE because the external field is changed abruptly */</span>
<a name="l00492"></a>00492     <span class="keywordflow">else</span> <span class="keywordflow">if</span> (nstep&gt;0) {
<a name="l00493"></a>00493       ierr = <a class="code" href="mytscreatepvode_8c.html#a4ca0e9d74cde3d8e01ad9701426444da">PVodeReInit</a>(gdata);CHKERRQ(ierr);
<a name="l00494"></a>00494     }
<a name="l00495"></a>00495   }
<a name="l00496"></a>00496 
<a name="l00497"></a>00497 
<a name="l00498"></a>00498   <span class="comment">/* disturb magnetization distribution with random vector */</span>
<a name="l00499"></a>00499   <span class="keywordflow">if</span> (magdist&gt;0.0) {
<a name="l00500"></a>00500     <span class="keywordflow">if</span> (magdist_last_time==PETSC_MIN) {
<a name="l00501"></a>00501       magdist_last_time = time_ns;
<a name="l00502"></a>00502     }
<a name="l00503"></a>00503     <span class="keywordflow">else</span> <span class="keywordflow">if</span> (time_ns - magdist_last_time &gt; magdist_ns) {
<a name="l00504"></a>00504       <span class="comment">/* randomly distort M */</span>
<a name="l00505"></a>00505       PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;Disturbing magnetization distribution at %g ns by %g.\n&quot;</span>,time_ns,magdist);
<a name="l00506"></a>00506       ierr = <a class="code" href="distortvec_8c.html#a8bf0a9f33e000474112d918b05b1b377">DistortVec</a>(rctx,gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,magdist);CHKERRQ(ierr);
<a name="l00507"></a>00507 
<a name="l00508"></a>00508       <span class="comment">/* renormalize M */</span>
<a name="l00509"></a>00509       PetscReal devNorm;
<a name="l00510"></a>00510       devNorm=<a class="code" href="renormvec_8c.html#abba3d002260d6e3e062ac69a80300aa4">RenormVec</a>(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,1.0,<a class="code" href="griddata_8h.html#a26ab586dda1b8c780aa849e457c0cbad">D_EPS</a>,<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>);
<a name="l00511"></a>00511 
<a name="l00512"></a>00512       ierr = <a class="code" href="mytscreatepvode_8c.html#a4ca0e9d74cde3d8e01ad9701426444da">PVodeReInit</a>(gdata);CHKERRQ(ierr);
<a name="l00513"></a>00513 
<a name="l00514"></a>00514       magdist_last_time=time_ns;
<a name="l00515"></a>00515     }
<a name="l00516"></a>00516   }
<a name="l00517"></a>00517 
<a name="l00518"></a>00518 
<a name="l00519"></a>00519   <span class="comment">/* renormalize M _after_ WriteLog to have consistent data in logfile */</span>
<a name="l00520"></a>00520 
<a name="l00521"></a>00521   PetscReal devNorm;
<a name="l00522"></a>00522   devNorm=<a class="code" href="renormvec_8c.html#abba3d002260d6e3e062ac69a80300aa4">RenormVec</a>(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,1.0,renormtol,<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>);
<a name="l00523"></a>00523 
<a name="l00524"></a>00524   <span class="keywordflow">if</span> (PetscAbsReal(devNorm) &gt; renormtol) {
<a name="l00525"></a>00525     PetscPrintf(PETSC_COMM_WORLD,
<a name="l00526"></a>00526       <span class="stringliteral">&quot;t=%g ns: renormalized M because |%g| &gt; %g\n&quot;</span>,
<a name="l00527"></a>00527       time_ns,
<a name="l00528"></a>00528       devNorm,
<a name="l00529"></a>00529       renormtol
<a name="l00530"></a>00530     );
<a name="l00531"></a>00531 
<a name="l00532"></a>00532     <span class="comment">/* if renormalization occurs within 3 timesteps */</span>
<a name="l00533"></a>00533     <span class="keywordflow">if</span> (nstep&lt;3 &amp;&amp; reltol &gt; 1e-10) {
<a name="l00534"></a>00534       <span class="comment">/* adjust tolerances */</span>
<a name="l00535"></a>00535       ierr = <a class="code" href="checkiterationllg_8c.html#a4ff7d0e1586041652124b1189f59b881">adjtol</a>(gdata,1.0/tolscale);CHKERRQ(ierr);
<a name="l00536"></a>00536     }
<a name="l00537"></a>00537     <span class="keywordflow">else</span> {
<a name="l00538"></a>00538       <span class="comment">/* only reinit PVODE after renormalization */</span>
<a name="l00539"></a>00539       ierr = <a class="code" href="mytscreatepvode_8c.html#a4ca0e9d74cde3d8e01ad9701426444da">PVodeReInit</a>(gdata);CHKERRQ(ierr);
<a name="l00540"></a>00540     }
<a name="l00541"></a>00541   }
<a name="l00542"></a>00542   <span class="comment">/* check if timestep is very small */</span>
<a name="l00543"></a>00543   <span class="keywordflow">else</span> <span class="keywordflow">if</span> ((gdata-&gt;<a class="code" href="structGridData.html#a9eb9246406e97a2a4a8a9c471b11aa2a">time</a>-timelast)*gdata-&gt;<a class="code" href="structGridData.html#ad7a22de0cb266e66e8dbcb1bb147bae8">tscale</a>*1e9&lt;1e-5 &amp;&amp; nstep&gt;100) {
<a name="l00544"></a>00544     PetscInfo2(0,
<a name="l00545"></a>00545       <span class="stringliteral">&quot;Warning (t=%g ns): timestep is %g &lt; 1e-4\n&quot;</span>,
<a name="l00546"></a>00546       time_ns,
<a name="l00547"></a>00547       (gdata-&gt;<a class="code" href="structGridData.html#a9eb9246406e97a2a4a8a9c471b11aa2a">time</a>-timelast)*gdata-&gt;<a class="code" href="structGridData.html#ad7a22de0cb266e66e8dbcb1bb147bae8">tscale</a>*1e9
<a name="l00548"></a>00548     );
<a name="l00549"></a>00549 <span class="comment">/*</span>
<a name="l00550"></a>00550 <span class="comment">    ierr = adjtol(gdata,1.0/tolscale);CHKERRQ(ierr);</span>
<a name="l00551"></a>00551 <span class="comment">    ierr = adjtoldem(gdata,1.0/tolscale);CHKERRQ(ierr);</span>
<a name="l00552"></a>00552 <span class="comment">*/</span>
<a name="l00553"></a>00553 
<a name="l00554"></a>00554     <span class="keywordflow">if</span> (gdata-&gt;<a class="code" href="structGridData.html#a776aed135c71061b20ec61cdbb39604d">VHdem</a>!=PETSC_NULL &amp;&amp;
<a name="l00555"></a>00555           (gdata-&gt;<a class="code" href="structGridData.html#a93b54f2f6a796c1528054e5b91977287">Edem</a>-Edemold)*dEdem1&lt;0 &amp;&amp;
<a name="l00556"></a>00556           (gdata-&gt;<a class="code" href="structGridData.html#a93b54f2f6a796c1528054e5b91977287">Edem</a>-Edemold)*dEdem2&gt;0) {
<a name="l00557"></a>00557       PetscInfo2(0,
<a name="l00558"></a>00558         <span class="stringliteral">&quot;and Edem oscillates: %g %g\n&quot;</span>,
<a name="l00559"></a>00559         gdata-&gt;<a class="code" href="structGridData.html#a93b54f2f6a796c1528054e5b91977287">Edem</a>,
<a name="l00560"></a>00560         Edemold
<a name="l00561"></a>00561       );
<a name="l00562"></a>00562 <span class="comment">/*</span>
<a name="l00563"></a>00563 <span class="comment">      PetscPrintf(PETSC_COMM_WORLD,</span>
<a name="l00564"></a>00564 <span class="comment">        &quot;and Edem oscillates: %g %g %g %g\n&quot;,</span>
<a name="l00565"></a>00565 <span class="comment">        gdata-&gt;Edem,</span>
<a name="l00566"></a>00566 <span class="comment">        Edemold,</span>
<a name="l00567"></a>00567 <span class="comment">        gdata-&gt;Edem-Edemold,</span>
<a name="l00568"></a>00568 <span class="comment">        dEdem1,</span>
<a name="l00569"></a>00569 <span class="comment">        dEdem2</span>
<a name="l00570"></a>00570 <span class="comment">      );</span>
<a name="l00571"></a>00571 <span class="comment">*/</span>
<a name="l00572"></a>00572 <span class="comment">/*</span>
<a name="l00573"></a>00573 <span class="comment">      ierr = adjtoldem(gdata,1.0/tolscale);CHKERRQ(ierr);</span>
<a name="l00574"></a>00574 <span class="comment">*/</span>
<a name="l00575"></a>00575     }
<a name="l00576"></a>00576   }
<a name="l00577"></a>00577   <span class="comment">/* check if Edem oscillates */</span>
<a name="l00578"></a>00578   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (gdata-&gt;<a class="code" href="structGridData.html#a776aed135c71061b20ec61cdbb39604d">VHdem</a>!=PETSC_NULL &amp;&amp;
<a name="l00579"></a>00579            (gdata-&gt;<a class="code" href="structGridData.html#a93b54f2f6a796c1528054e5b91977287">Edem</a>-Edemold)*dEdem1&lt;0 &amp;&amp;
<a name="l00580"></a>00580            (gdata-&gt;<a class="code" href="structGridData.html#a93b54f2f6a796c1528054e5b91977287">Edem</a>-Edemold)*dEdem2&gt;0) {
<a name="l00581"></a>00581     PetscInfo2(0,
<a name="l00582"></a>00582       <span class="stringliteral">&quot;Warning (t=%g ns): Edem oscillates: %g\n&quot;</span>,
<a name="l00583"></a>00583       time_ns,
<a name="l00584"></a>00584       gdata-&gt;<a class="code" href="structGridData.html#a93b54f2f6a796c1528054e5b91977287">Edem</a>
<a name="l00585"></a>00585     );
<a name="l00586"></a>00586 <span class="comment">/*</span>
<a name="l00587"></a>00587 <span class="comment">    PetscPrintf(PETSC_COMM_WORLD,</span>
<a name="l00588"></a>00588 <span class="comment">      &quot;Warning (t=%g ns): Edem oscillates: %g %g %g %g %g\n&quot;,</span>
<a name="l00589"></a>00589 <span class="comment">      time_ns,</span>
<a name="l00590"></a>00590 <span class="comment">      gdata-&gt;Edem,</span>
<a name="l00591"></a>00591 <span class="comment">      Edemold,</span>
<a name="l00592"></a>00592 <span class="comment">      gdata-&gt;Edem-Edemold,</span>
<a name="l00593"></a>00593 <span class="comment">      dEdem1,</span>
<a name="l00594"></a>00594 <span class="comment">      dEdem2</span>
<a name="l00595"></a>00595 <span class="comment">    );</span>
<a name="l00596"></a>00596 <span class="comment">*/</span>
<a name="l00597"></a>00597 <span class="comment">/*</span>
<a name="l00598"></a>00598 <span class="comment">    ierr = adjtoldem(gdata,1.0/tolscale);CHKERRQ(ierr);</span>
<a name="l00599"></a>00599 <span class="comment">*/</span>
<a name="l00600"></a>00600   }
<a name="l00601"></a>00601   <span class="comment">/* don&#39;t do this !?</span>
<a name="l00602"></a>00602 <span class="comment">    may lead to</span>
<a name="l00603"></a>00603 <span class="comment">    large tolerances-&gt;large error-&gt;norm not preserved-&gt;</span>
<a name="l00604"></a>00604 <span class="comment">    minimum time step-&gt;very slow simulation</span>
<a name="l00605"></a>00605 <span class="comment">  */</span>
<a name="l00606"></a>00606   <span class="keywordflow">else</span> {
<a name="l00607"></a>00607     <span class="keywordtype">long</span> <span class="keywordtype">int</span> ncfn;
<a name="l00608"></a>00608     <span class="keyword">extern</span> <span class="keywordtype">void</span> *cvode_mem;
<a name="l00609"></a>00609     CVodeGetNumNonlinSolvConvFails(cvode_mem,&amp;ncfn);
<a name="l00610"></a>00610     <span class="keywordflow">if</span> (nstep &gt; 30 &amp;&amp;
<a name="l00611"></a>00611         devNorm &lt;= renormtol/100.0 &amp;&amp;
<a name="l00612"></a>00612         <a class="code" href="checkiterationllg_8c.html#a29c891f86d4e498ef78fe8d82ac95ea6">reltol</a> &lt;= tol/10.0 &amp;&amp;
<a name="l00613"></a>00613         <a class="code" href="checkiterationllg_8c.html#a29c891f86d4e498ef78fe8d82ac95ea6">reltol</a> &lt;= 1e-2 &amp;&amp;
<a name="l00614"></a>00614         ncfn == 0) {
<a name="l00615"></a>00615       ierr = <a class="code" href="checkiterationllg_8c.html#a4ff7d0e1586041652124b1189f59b881">adjtol</a>(gdata,tolscale);CHKERRQ(ierr);
<a name="l00616"></a>00616     }
<a name="l00617"></a>00617   }
<a name="l00618"></a>00618 
<a name="l00619"></a>00619   timelast=gdata-&gt;<a class="code" href="structGridData.html#a9eb9246406e97a2a4a8a9c471b11aa2a">time</a>;
<a name="l00620"></a>00620 
<a name="l00621"></a>00621   dEdem2=dEdem1;
<a name="l00622"></a>00622   dEdem1=gdata-&gt;<a class="code" href="structGridData.html#a93b54f2f6a796c1528054e5b91977287">Edem</a>-Edemold;
<a name="l00623"></a>00623   Edemold=gdata-&gt;<a class="code" href="structGridData.html#a93b54f2f6a796c1528054e5b91977287">Edem</a>;
<a name="l00624"></a>00624 
<a name="l00625"></a>00625   <a class="code" href="griddata_8h.html#a9a4d090c28602d7ff7ec883fb6f413db">MagparFunctionProfReturn</a>(0);
<a name="l00626"></a>00626 }
</pre></div></div>
  <hr>
  <address>
    magpar - Parallel Finite Element Micromagnetics Package<br>
    Copyright (C) 2002-2010 Werner Scholz
  </address>
  </body>
</html>

